//+------------------------------------------------------------------+
//|                                                  Force Index.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


#property indicator_separate_window
#property  indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_width1 4
#property indicator_width2 2





extern int    swingCount = 5;
extern double speed      = 1.0;
extern int    mamode     = 3;
extern int    Price      = 0;




double BearsBuffer[];
double BullsBuffer[];
double TempBuffer[];
double swingBuffer[];





int init()
  {
   IndicatorBuffers(4);
   SetIndexBuffer(0,BearsBuffer); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,BullsBuffer); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,TempBuffer);
   SetIndexBuffer(3,swingBuffer);
   
   IndicatorShortName("alb BullBear");
   
   
   return(0);
  }

int deinit() { return(0); }




int start()
  {
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
      int swing = 0;
         if (High[i]>High[i+1] && High[i+1]>High[i+2] && Low[i+2] < Low[i+3] && Low[i+3] < Low[i+4]) swing = -1;
         if (Low[i] < Low[i+1] && Low[i+1] < Low[i+2] && High[i+2]>High[i+3] && High[i+3]>High[i+4]) swing =  1;
      swingBuffer[i] = swing;
   
      //
      //
      //
      //
      //
      int k = i;
      int n = 0;
      for (; (k<Bars) && (n<swingCount); k++) if(swingBuffer[k]!=0) n++;
      
      double BearsBullsPeriod = MathMax(MathRound((k-i)/swingCount/speed),1);
             TempBuffer[i]    = iMA(NULL,0,BearsBullsPeriod,0,mamode,Price,i);
             BearsBuffer[i]   = Low[i] -TempBuffer[i];
             BullsBuffer[i]   = High[i]-TempBuffer[i];
   }

   return(0);
  }
//+------------------------------------------------------------------+

